<template>
    <div>
        <custom-card>
            <auto-datatable
                ref="dt"
                model="UserTopup"
                :filters="[
                    [
                        {label: $t('user'), name: 'f-has-like-user-username', type: 'text'},
                    ],
                    [
                        {label: $t('created_at') + '(' + $t('from') + ')', name: 'f-date-from-created_at', type: 'date'},
                        {label: $t('created_at') + '(' + $t('to') + ')', name: 'f-date-to-created_at', type: 'date'},
                    ],
                     {
                        label: $t('status'),
                        name: 'f-status',
                        type: 'select',
                        options: [
                            {text: $t('pending'), value: 0},
                            {text: $t('completed'), value: 1},
                            {text: $t('canceled'), value: 2},
                        ]
                    }
                ]"
                :headers="[
                    {label: '#', name: 'id'},
                    {label: $t('actions'), name: 'actions'},
                    {label: $t('user'), name: 'user_username', column: 'user_id'},
                    {label: $t('crypto'), name: 'from_crypto_symbol'},
                    {label: $t('amount'), name: 'topup_amount'},
                    {label: $t('status'), name: 'status_explained', column: 'status'},
                    {label: $t('transaction_hash'), name: 'transaction_hash'},
                    {label: $t('created_at'), name: 'created_at'},
                ]"
            >
                <template #default="{records}">
                    <tr
                        v-for="(record, i) in records"
                        :key="i"
                    >
                        <td>{{ i+1 }}</td>
                        <td>
                            <div class="flex justify-start space-x-1">
                                <edit-button
                                    v-if="parseInt(record.status) === 0"
                                    @click="model = record"
                                />
                                <view-button
                                    v-else
                                    @click="model = record"
                                />
                            </div>
                        </td>
                        <td>{{ record.user_username }}</td>
                        <td>{{ record.from_crypto_symbol }}</td>
                        <td>{{ $helper.fundFormat(record.topup_amount, 2) }}</td>
                        <td>{{ record.status_explained }}</td>
                        <td>{{ record.transaction_id }}</td>
                        <td>{{ $helper.dateTimeFormat(record.created_at) }}</td>
                    </tr>
                </template>
            </auto-datatable>
        </custom-card>
        <panel-modal
            v-if="model"
            :has-footer="false"
            @close="model = null"
        >
            <template #body>
                <model-form
                    :form-model="model"
                    @update="updateRow"
                />
            </template>
        </panel-modal>
    </div>
</template>
<script setup>
import CustomCard from "~/components/custom-card.vue";
import PanelModal from "~/components/panel-modal.vue";
import AutoDatatable from "~/components/auto-datatable.vue";
import EditButton from "~/components/button/edit-button.vue";
import ViewButton from "~/components/button/view-button.vue";
import {inject, ref} from "vue";
import ModelForm from "./model-form.vue";

const $helper = inject('$helper');
const model = ref(null);
const dt = ref();

const updateRow = async () => {
    model.value = null;

    await dt.value.loadData();
};
</script>
